use crate::server::STATE_FILE;
use std::path::PathBuf;
use type_toppings::ResultExt;

#[tracing::instrument]
pub async fn run_migrations() {
    migrate_state_file().await;
}

/// State file moved to datastore/private
#[tracing::instrument]
async fn migrate_state_file() {
    let m = PathBuf::from("state.ron");
    if m.try_exists().expect_or_report_with(|| format!("Failed to read {}", m.display())) {
        tracing::warn!("MIGRATING STATE FILE");
        let p = PathBuf::from(STATE_FILE);
        tokio::fs::create_dir_all(p.parent().unwrap()).await.unwrap_or_report();
        tokio::fs::rename(m, &p).await.unwrap_or_report();
    }
}
